<%--
 * Component: cases
 *
 * Description:
 *    Creates a graphic button with the given properties and text
 *
 * Params:
 * 
 *    cLabel:    the text (should be passed URLEncoded in UTF-8, such as 
 *                       erd (Hun for forest) is erd%C5%91)
 *    cBig:      big button for large screen
 *    cDisabled: disabled button (greyed out text)
 *    cHidden:   red blinking text
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
 *
 * utilizes imagemagick with the following command
 *
 * convert buttonbase.gif -font Helvetica -pointsize 23 
 *   -fill '#404040' // if regular, #C0C0C0 if disabled
 *   -draw "text 18, 25 'Save'"
 *   -scale '50%' // if small image
 *    Save.gif
 *
--%><%@
	page import="imagemed.imsession.*,imagemed.util.*,java.util.*,java.io.*, java.net.*" 

%><%!
	static final int SIZE = 65536;

%><%

	String label = request.getParameter( "cLabel" );
	if ( label == null ) {
		String labelID = request.getParameter( "cLocalizedLabel" );
		if (labelID != null) {
			try {
				label = LocalizedMessage.getSimpleMessage( labelID );
			}
			catch (Throwable th) {
				label = labelID;
			}
		}
		else {
			label = "Button";
		}
	}

	// we are forcing the GET parameter to be UTF-8 in tomcat's server.xml
	// and since exec will use the system default encoding to pass on 
	// we create a new system encoding string (label_sys)
	// using the array of bytes encoded in utf-8 from the parameter
	// and pass this newly created string to ImageMagick
	// -- worked fine on Debian en_us.UTF-8 and en_us.ISO-8859-1
	// tested it changing OS charset by sudo dpkg-reconfigure locales
	
	String label_sys = new String( label.getBytes( "UTF-8" ) );
	
	boolean bDisabled = request.getParameter( "cDisabled" ) != null;
	boolean bBig = request.getParameter( "cBig" ) != null;
	boolean bForce = request.getParameter( "cForce" ) != null;

	double overflow = label.length() > 10 ? label.length() - 10 : 0;

	// Directories

	String bhome=IMEnvBase.getEnv( "ART_HOME" );
	String chome=IMEnvBase.getEnv( "VAR" ) + "/botton-cache";
	
	// we'll want to have the label encoded as an UTF-8 encoded, URL encoded string
	// to be used as a filename.
	
	// when passing arguments such as Save & Next, the '&' character must be encoded
	// and the browser doesn't automatically does that for that specific character
	// so if using the buttonize.jsp directly from the URL bar, should use the encoded %26
	
	// the GET parameter is already UTF-8, so we just encode it using UTF-8 charset
	
	String encodedLabel = URLEncoder.encode( label, "UTF-8" );
	String fname = chome + "/" + encodedLabel
		+ ( bDisabled ? ".d" : "" ) 
		+ ( bBig ? ".big" : "" ) + ".gif";
	
	File fCacheDir = new File( chome );
	fCacheDir.mkdirs();

	File f = new File( fname );

	if (! f.exists() || bForce ) {
		Vector<String> cmd = new Vector<String>();
		cmd.add( IMEnvBase.getEnv( "IMAGEMAGICK_HOME" ) + "/bin/convert" );
		cmd.add( bhome+ "/buttonbase.gif" );
		cmd.add( "-font" );
		//cmd.add( bhome+"/arial.ttf" );
		cmd.add( bhome + "/FreeSans.ttf" );
		cmd.add( "-pointsize" );
		cmd.add( "25" );
		cmd.add( "-kerning" );
 		cmd.add( "-" + ( overflow / 4.3 ) );
		cmd.add( "-fill" );
		cmd.add( bDisabled ? "#C0C0C0" : "#404040" );
		cmd.add( "-draw" );
		cmd.add( "text " + Math.max( 3, Math.floor( 18 - overflow * 2.3 ) ) + " ,25 '" + label_sys + "'" );
		cmd.add( "-scale" );
		cmd.add( bBig ? "100%"  : "50%" );
		cmd.add( fname );

		RunCommandResult rcr = Helper.runCommandEx( cmd.toArray ( new String[ 0 ] ), null );
	}

	// return the gif

	response.setContentType( "image/gif" );

	response.setDateHeader( "Last-Modified", f.lastModified() );
	response.setHeader( "ETag", "" + f.lastModified() );
	response.setDateHeader( "Expires", System.currentTimeMillis() + 10800000 ); // 3 hours from now
	response.setHeader( "Cache-Control", "max-age=10800" ); // 3 hours
	
	long from = 0, to = f.length();
	FileInputStream inStream;
	ServletOutputStream outStream = response.getOutputStream();
	inStream = new FileInputStream( fname );
	byte[] buffer = new byte[ SIZE ];
	int nBytes;

	while ( to > from ) {
		int r = SIZE;
		if ( to - from < SIZE ) {
			r = (int) ( to - from );
		}
		nBytes = inStream.read( buffer, 0, r );

		outStream.write( buffer, 0, nBytes );
		from += nBytes;
	}
	inStream.close();

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
